void SetCharSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;

	static int prob, tw, ga, rwref, rwwil, rwzaeh, attack, skills, prestige, maxlvl, name, attr[6], valcount;

	if (header)
	{
		prob = GetValNumber(Vals, "Probability", Number);
		ga = GetValNumber(Vals, "GAType", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zh", Number);
		attack = GetValNumber(Vals, "Attack", Number);
		skills = GetValNumber(Vals, "Skills", Number);
		prestige = GetValNumber(Vals, "Prest", Number);
		maxlvl = GetValNumber(Vals, "MaxLvl", Number);
		name = GetValNumber(Vals, "Name", Number);
		tw = GetValNumber(Vals, "TW", Number);
		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in CharSource Database\n");
		quitprog();
	}

	strcpy(((clsCharSource*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[tw], "W%d", &(((clsCharSource*) TargetStruct)->TW));
	for (i = 0;i < 6;i++)
	{
		sscanf(Vals[attr[i]], "%d", &(((clsCharSource*) TargetStruct)->AttributePriority[i]));
	}
	sscanf(Vals[prob], "%d", &(((clsCharSource*) TargetStruct)->Probability));
	sscanf(Vals[ga], "%d", &(((clsCharSource*) TargetStruct)->GA));
	sscanf(Vals[rwref], "%d", &(((clsCharSource*) TargetStruct)->RWRef));
	sscanf(Vals[rwwil], "%d", &(((clsCharSource*) TargetStruct)->RWWil));
	sscanf(Vals[rwzaeh], "%d", &(((clsCharSource*) TargetStruct)->RWZaeh));
	sscanf(Vals[attack], "%d", &(((clsCharSource*) TargetStruct)->PreferedAttack));
	sscanf(Vals[skills], "%d", &(((clsCharSource*) TargetStruct)->Skills));
	sscanf(Vals[prestige], "%d", &(((clsCharSource*) TargetStruct)->Prestige));
	sscanf(Vals[maxlvl], "%d", &(((clsCharSource*) TargetStruct)->MaxLevel));
}

int GetCharNumber(char* CharName)
{
	int i;
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (strcmp(CharName, Source.CharSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Char not found(%s)\n", CharName);
	quitprog();
	return(0);
}

int CharSourceInit()
{
	int i;
	FILE* fChar;

	if (DebugOutput) {printf("Opening Character Templates (%s)\t", CharFile);}
	fChar = fopen(CharFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading character Templates\t\t\t");}
	ProcessLine(fChar, &SetCharSource, NULL, true);
	Source.CharSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.CharSourceCount);}
	Source.CharSource = new clsCharSource[Source.CharSourceCount];
	if (Source.CharSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.CharSourceCount;i++)
	{
		ProcessLine(fChar, &SetCharSource, &Source.CharSource[i], false);
		if (DebugOutput) {printf("%s ", Source.CharSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void CharSourceExit()
{
	delete[] Source.CharSource;
}