void SetFeatSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int MultiPos, name, epic, valcount;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name, Number);
		}
		MultiPos = GetValNumber(Vals, "Multi", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		name = GetValNumber(Vals, "Name", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in FeatSource Database\n");
		quitprog();
	}
	
	strcpy(((clsFeatSource*) TargetStruct)->Name, Vals[name]);
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		sscanf(Vals[ClassPosition[i]], "%d", &(((clsFeatSource*) TargetStruct)->Probability[i]));
	}
	sscanf(Vals[MultiPos], "%d", &(((clsFeatSource*) TargetStruct)->MultipleTimes));
	sscanf(Vals[epic], "%d", &(((clsFeatSource*) TargetStruct)->Epic));
}

int GetFeatNumber(char* FeatName, int uncomplete = 0)
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (strcmp(FeatName, Source.FeatSource[i].Name) == 0)
		{
			return(i);
		}
		if (uncomplete == 1 && strstr(Source.FeatSource[i].Name, FeatName) != 0)
		{
			return(i);
		}
	}
	printf("Feat not found(%s)\n", FeatName);
	quitprog();
	return(0);
}

int FeatSourceInit()
{
	int i;
	FILE* fChar;

	if (DebugOutput) {printf("Opening Feat List (%s)\t\t\t", FeatFile);}
	fChar = fopen(FeatFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Feat List\t\t\t\t");}
	ProcessLine(fChar, &SetFeatSource, NULL, true);
	Source.FeatSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.FeatSourceCount);}
	Source.FeatSource = new clsFeatSource[Source.FeatSourceCount];
	if (Source.FeatSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		ProcessLine(fChar, &SetFeatSource, &Source.FeatSource[i], false);
		if (DebugOutput) {printf("%s ", Source.FeatSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void FeatSourceExit()
{
	delete[] Source.FeatSource;
}