struct ProfileFeatStruct
{
	int Feat;
};

struct ProfileClassStruct
{
	int Class;
	int Level;
};

struct ProfileWeaponStruct
{
	int Weapon;
};

struct ProfileSkillStruct
{
	int Skill;
	int MinLvl;
	int MaxLvl;
};

struct ProfileStruct
{
	char ProfileName[256];
	
	ProfileClassStruct Classes[32];
	int ClassCount;

	ProfileWeaponStruct Weapons[32];
	int WeaponCount;
	
	ProfileFeatStruct Feats[32];
	int FeatCount;

	ProfileSkillStruct Skills[32];
	int SkillCount;
	
	int Spells[128];
	int SpellCount;

	int Armor;
	int ArmorType;

	int AttackType[2];

	int Race;
};

ProfileStruct* Profiles;
int ProfileCount = 0;

char valuebuffer[16385];
char* valuepointer;
void PrepareString(int num, char* Key)
{
	int j, k;
	GetPrivateProfileString(Profiles[num].ProfileName, Key, "", valuebuffer, 16384, ProfileFile);
	k = strlen(valuebuffer);
	valuebuffer[k + 1] = 0;
	for (j = 0;j < k;j++)
	{
		if (valuebuffer[j] == 32) {printf("Error in Profile Database\n");quitprog();}
		if (valuebuffer[j] == 44) {valuebuffer[j] = 0;}
		if (valuebuffer[j] == 58) {valuebuffer[j] = 32;}
	}
	valuepointer = valuebuffer;
}

char tempbuffer[16384];
int tempint, tempint2;

int ProfileSourceInit()
{
	char profilebuffer[16385];
	char* profilepointer = profilebuffer;
	int i;
	GetPrivateProfileSectionNames(profilebuffer, 16384, ProfileFile);
	if (DebugOutput) {printf("Profiles: ");}
	while (*profilepointer != 0)
	{
		if (DebugOutput) {printf(" %s ", profilepointer);}
		profilepointer += strlen(profilepointer) + 1;
		ProfileCount++;
	}
	if (DebugOutput) {printf("\n");}

	Profiles = new ProfileStruct[ProfileCount];
	if (Profiles == 0)
	{
		printf("Memmory Allocation Error\n");
		quitprog();
	}
	profilepointer = profilebuffer;

	for (i = 0;i < ProfileCount;i++)
	{
		strcpy(Profiles[i].ProfileName, profilepointer);
		profilepointer += strlen(profilepointer) + 1;
		
		PrepareString(i, "Classes");
		Profiles[i].ClassCount = 0;
		while (*valuepointer != 0)
		{
			sscanf(valuepointer, "%s %d", tempbuffer, &tempint);
			Profiles[i].Classes[Profiles[i].ClassCount].Class = GetCharNumber(tempbuffer);
			Profiles[i].Classes[Profiles[i].ClassCount].Level = tempint;
			Profiles[i].ClassCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "AttackType");
		Profiles[i].AttackType[0] = valuebuffer[0] - 48;
		Profiles[i].AttackType[1] = valuebuffer[1] - 48;

		PrepareString(i, "Weapons");
		Profiles[i].WeaponCount = 0;
		while (*valuepointer != 0)
		{
			Profiles[i].Weapons[Profiles[i].WeaponCount].Weapon = GetEquipNumber(valuepointer);
			Profiles[i].WeaponCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Feats");
		Profiles[i].FeatCount = 0;
		while (*valuepointer != 0)
		{
			Profiles[i].Feats[Profiles[i].FeatCount].Feat = GetFeatNumber(valuepointer);
			Profiles[i].FeatCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Spells");
		Profiles[i].SpellCount = 0;
		while (*valuepointer != 0)
		{
			Profiles[i].Spells[Profiles[i].SpellCount] = GetSpellNumber(valuepointer);
			Profiles[i].SpellCount++;
			valuepointer += strlen(valuepointer) + 1;
		}
		
		PrepareString(i, "Skills");
		Profiles[i].SkillCount = 0;
		while (*valuepointer != 0)
		{
			sscanf(valuepointer, "%s %d %d", tempbuffer, &tempint, &tempint2);
			Profiles[i].Skills[Profiles[i].SkillCount].Skill = GetSkillNumber(tempbuffer);
			Profiles[i].Skills[Profiles[i].SkillCount].MinLvl = tempint;
			Profiles[i].Skills[Profiles[i].SkillCount].MaxLvl = tempint2;
			Profiles[i].SkillCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Armor");
		sscanf(valuepointer, "%s %d", tempbuffer, &tempint);
		Profiles[i].Armor = GetEquipNumber(tempbuffer);
		Profiles[i].ArmorType = tempint;

		PrepareString(i, "Race");
		Profiles[i].Race = GetRaceNumber(valuepointer);




	}

	/*printf("ok");
	getchar();
	getchar();
	exit(0);*/
	return(0);
}

void ProfileSourceExit()
{
	delete[] Profiles;
}
